/*
 * BarCodePicker.java
 *
 * Created on March 2, 2000, 1:17 PM
 */
 package demo;


import java.awt.print.*;
import java.awt.*;
import java.awt.Toolkit.*;
import java.awt.geom.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.Image;
import javax.swing.border.*;
import java.beans.*;
import dsx.JBarCodePro2.*;

/** 
 *
 * @author  EKong
 * @version 
 */
public class BarCodePicker  extends javax.swing.JFrame implements Printable {
static String SymbolName[]={
    "Code 11",
	"Codabar",
	"MSI Code",
	"Code 39",
	"Extended Code 39",
	"Code 93",
	"Code 128",
	"EAN 128",
	"UPC A",
	"UPC E",
	"EAN 13",
	"EAN 8",
	"JAN 13",
	"JAN 8",
	"HIBC LIC  39",
	"HIBC LIC 128",
	"HIBC EAN/UCC128",
	"HIBC EAN/UCC25",
	"Interleaved 2 of 5",
    "POSTNET"};
  /** Creates new form BarCodePicker */
  public BarCodePicker() {
	barCodeBean1 = new dsx.JBarCodePro2.BarCodeBean ();
	
	barCodeBean1.addPropertyChangeListener(new PropertyChangeListener()

	{
	  
	   public void propertyChange(PropertyChangeEvent evt)
	   {
		  BeanPropertyChanged(evt);	
	
	   }
	}
	);

    jPanel2 = new javax.swing.JPanel ();
    jSymbolCombo = new javax.swing.JComboBox ();
	jUnitCombo =new javax.swing.JComboBox();
    jRotationCombo = new javax.swing.JComboBox ();
	j128StartTypeCombo=new javax.swing.JComboBox ();
    jAlignCombo = new javax.swing.JComboBox ();
    jBorderCombo = new javax.swing.JComboBox ();
    jMessageField = new javax.swing.JTextField ();
	jSuppleField = new javax.swing.JTextField();
    jNarrowField = new javax.swing.JTextField ();
	jQZoneField= new javax.swing.JTextField ();
    jHeightField = new javax.swing.JTextField ();
	jRatioField= new javax.swing.JTextField ();
	jTransparentCheckBox=new javax.swing.JCheckBox("Transparent");
	jCheckDigitsCheckBox=new javax.swing.JCheckBox("Check Digits Enabled");
	jHRDisplayCheckBox=new javax.swing.JCheckBox("HR Display");
	jBearerCheckBox=new javax.swing.JCheckBox("Bearer Mode");
	jHRFontButton = new javax.swing.JButton ();
	jTopFontButton =new javax.swing.JButton ();
	jBottomFontButton =new javax.swing.JButton ();
	jBGColorButton = new javax.swing.JButton ();
	jBarColorButton =new javax.swing.JButton ();

	jTopCommentArea=new javax.swing.JTextArea();
	jBottomCommentArea=new javax.swing.JTextArea();

    jPrint = new javax.swing.JButton ();
    addWindowListener (new java.awt.event.WindowAdapter () {
      public void windowClosing (java.awt.event.WindowEvent evt) {
        exitForm (evt);
      }
    }
    );

    barCodeBean1.setBarHRFont (new java.awt.Font ("Arial", 0, 12));
	
    JPanel pfff=new JPanel();
	pfff.add(barCodeBean1);
    getContentPane().add (pfff, java.awt.BorderLayout.CENTER);

 //  getContentPane().add (barCodeBean1, java.awt.BorderLayout.CENTER);
    jPanel2.setLayout (new java.awt.GridLayout (5, 5));

  // init barcode data

    barCodeBean1.setBarBottomCommentFont (new java.awt.Font ("Arial", 0, 14));
    barCodeBean1.setBarTopCommentFont (new java.awt.Font ("Arial", 0, 14));
    barCodeBean1.setBarBottomComment ("Bottom Comment1\nBottom Comment2");
    barCodeBean1.setBarTopComment ("Top Comment");
    barCodeBean1.setBarHRFont (new java.awt.Font ("Arial", 0, 12));
    barCodeBean1.setBarMessage ("12345678");
	barCodeBean1.setBarHRFont(new java.awt.Font ("Arial", 0, 12));
	barCodeBean1.setBackground(Color.white);
	barCodeBean1.setForeground(Color.black);

    jSymbolCombo.setBorder(BorderFactory.createTitledBorder("Symbology"));

	for(int i=0;i<SymbolName.length;i++)
		jSymbolCombo.addItem( SymbolName[i]);
    
	jSymbolCombo.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				JComboBox cb=(JComboBox)e.getSource();
				int isec=cb.getSelectedIndex();
				barCodeBean1.setBarSymbology(isec);
				validate();
		}
	}
	);  

	jPanel2.add (jSymbolCombo);
	
	JPanel jparpanel=new JPanel();
	jparpanel.setLayout (new java.awt.BorderLayout ()); 
	jparpanel.add(jPanel2,java.awt.BorderLayout.CENTER);

	JPanel jcommentpanel=new JPanel();
	jcommentpanel.setLayout(new java.awt.GridLayout(1,2));

	JPanel jtopcommentpanel=new JPanel();
	JPanel jbottomcommentpanel=new JPanel();
	jtopcommentpanel.setLayout(new java.awt.BorderLayout ()); 
	jbottomcommentpanel.setLayout(new java.awt.BorderLayout ()); 

	// top comment
	jTopCommentArea.setText(barCodeBean1.getBarTopComment());
	jTopCommentArea.addKeyListener (new java.awt.event.KeyAdapter () 
	  {
			public void keyReleased (java.awt.event.KeyEvent evt) 
			{
			    System.out.println(jTopCommentArea.getText());
				barCodeBean1.setBarTopComment(jTopCommentArea.getText());
				validate();
			}
		}
	  );


	  	  
    JScrollPane areaScrollPane = new JScrollPane(jTopCommentArea);
    areaScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    areaScrollPane.setBorder(BorderFactory.createTitledBorder("Top Comment"));
	jtopcommentpanel.add(areaScrollPane,java.awt.BorderLayout.CENTER);
	

	jBottomCommentArea.setText(barCodeBean1.getBarBottomComment());
	jBottomCommentArea.addKeyListener (new java.awt.event.KeyAdapter () 
	  {
			public void keyReleased (java.awt.event.KeyEvent evt) 
			{
				barCodeBean1.setBarBottomComment(jBottomCommentArea.getText());
				validate();
			}
		}
	  );



	areaScrollPane = new JScrollPane(jBottomCommentArea);
    areaScrollPane.setVerticalScrollBarPolicy(
                          JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    areaScrollPane.setBorder(BorderFactory.createTitledBorder("Bottom Comment"));
	jbottomcommentpanel.add(areaScrollPane,java.awt.BorderLayout.CENTER);



	jcommentpanel.add(jtopcommentpanel);
	jcommentpanel.add(jbottomcommentpanel);
	jparpanel.add(jcommentpanel,java.awt.BorderLayout.SOUTH);
    

    jUnitCombo.setBorder(BorderFactory.createTitledBorder("Unit"));
	jUnitCombo.addItem(" English Mils");
	jUnitCombo.addItem(" Metric Milli");
	jUnitCombo.addItem(" Point");
	jUnitCombo.setSelectedIndex(barCodeBean1.getBarScaleMode());
    
	jUnitCombo.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				JComboBox cb=(JComboBox)e.getSource();
				int isec=cb.getSelectedIndex();
				barCodeBean1.setBarScaleMode(isec);
				validate();
		}
	}
	);  

	jPanel2.add(jUnitCombo);
  
    jRotationCombo.setBorder(BorderFactory.createTitledBorder("Rotation"));
    jRotationCombo.addItem(new String("0"));
    jRotationCombo.addItem(new String("90"));
    jRotationCombo.addItem(new String("180"));
    jRotationCombo.addItem(new String("270")); 
	jRotationCombo.setSelectedIndex(barCodeBean1.getBarOrientation()/90);
        
       jRotationCombo.addActionListener (new ActionListener () {
          public void actionPerformed (ActionEvent e) {
             JComboBox cb=(JComboBox)e.getSource();
			 int isec=cb.getSelectedIndex();
			 barCodeBean1.setBarOrientation(isec*90);
			validate();

          }
        }
     );  
    
      jPanel2.add (jRotationCombo);
  
     jAlignCombo.setBorder(BorderFactory.createTitledBorder("Comment Align"));
	 jAlignCombo.addItem("Center");
		jAlignCombo.addItem("Left");
		jAlignCombo.addItem("Right");
		jAlignCombo.setSelectedIndex(barCodeBean1.getBarCommentAlignStyle());

		jAlignCombo.addActionListener (new ActionListener () {
          public void actionPerformed (ActionEvent e) {
             JComboBox cb=(JComboBox)e.getSource();
			 int isec=cb.getSelectedIndex();
			 barCodeBean1.setBarCommentAlignStyle(isec);
          }
        }
        );  

        jPanel2.add (jAlignCombo);
  
        jBorderCombo.setBorder(BorderFactory.createTitledBorder("Border"));
    	jBorderCombo.addActionListener (new ActionListener () {
          public void actionPerformed (ActionEvent e) {
             JComboBox cb=(JComboBox)e.getSource();
			 int isec=cb.getSelectedIndex();
			 barCodeBean1.setBarBorderStyle(isec);
			 validate();

          }
        }
        ); 
		
		jBorderCombo.addItem("None");	     
		jBorderCombo.addItem("Narrow broken lines");
		jBorderCombo.addItem("Wide broken lines");
		jBorderCombo.addItem("Narrow solid lines");
		jBorderCombo.addItem("Wide solid lines");
		jBorderCombo.setSelectedIndex(barCodeBean1.getBarBorderStyle());

		jPanel2.add (jBorderCombo);

        j128StartTypeCombo.setBorder(BorderFactory.createTitledBorder("Code 128 Set"));
		j128StartTypeCombo.addItem("Code 128 Set A");
		j128StartTypeCombo.addItem("Code 128 Set B");
		j128StartTypeCombo.addItem("Code 128 Set C");
		j128StartTypeCombo.addItem("Auto Select");

		

		j128StartTypeCombo.addActionListener (new ActionListener () {
          public void actionPerformed (ActionEvent e) {
             JComboBox cb=(JComboBox)e.getSource();
			 int isec=cb.getSelectedIndex();
			 barCodeBean1.setBar128Type(isec);
			 validate();

          }
        }
        ); 

		jPanel2.add(j128StartTypeCombo);
        jMessageField.setBorder(BorderFactory.createTitledBorder("Message"));
    
        jMessageField.setText (barCodeBean1.getBarMessage());

        jMessageField.addKeyListener (new java.awt.event.KeyAdapter () {
          public void keyReleased (java.awt.event.KeyEvent evt) {
				JTextField jtmpfield=(JTextField)evt.getSource();
				String s=jtmpfield.getText();
				barCodeBean1.setBarMessage(s);
			    validate();

          }
        }
        );       
    
		jPanel2.add (jMessageField);


		// add supplement
        jSuppleField.setBorder(BorderFactory.createTitledBorder("Supplement"));
		jSuppleField.setText(barCodeBean1.getBarSupplement());

		jSuppleField.addKeyListener (new java.awt.event.KeyAdapter () {
           public void keyReleased (java.awt.event.KeyEvent evt) {
				JTextField jtmpfield=(JTextField)evt.getSource();
				String s=jtmpfield.getText();
				barCodeBean1.setBarSupplement(s);
				validate();

          }
        }
        );  
		jPanel2.add(jSuppleField);  
		
        jNarrowField.setBorder(BorderFactory.createTitledBorder("Narrow Width"));
        jNarrowField.setText ((new Integer(barCodeBean1.getBarNarrowWidth())).toString());

		jNarrowField.addKeyListener (new java.awt.event.KeyAdapter () {
          public void keyReleased (java.awt.event.KeyEvent evt) {
				JTextField jtmpfield=(JTextField)evt.getSource();
				String s=jtmpfield.getText();
				
			    short shno;
				try
				{
				  shno=(short)Integer.parseInt(s);
				}
				catch(NumberFormatException e)
				{
				  shno=0;
				}	
				barCodeBean1.setBarNarrowWidth(shno);
				validate();

          }
        }
        );     
        jPanel2.add (jNarrowField);

         // add quietzone
        jQZoneField.setBorder(BorderFactory.createTitledBorder("Quiet Zone"));
        jQZoneField.setText ((new Integer(barCodeBean1.getBarQuietZone())).toString());

		jQZoneField.addKeyListener (new java.awt.event.KeyAdapter () {
          public void keyReleased (java.awt.event.KeyEvent evt) {
				JTextField jtmpfield=(JTextField)evt.getSource();
				String s=jtmpfield.getText();
				short shno=0;
				try
				{
				   shno=(short)Integer.parseInt(s);
				}
				catch(NumberFormatException e)
				{
				}
				barCodeBean1.setBarQuietZone(shno);
				validate();

          }
        }
        );     
        jPanel2.add (jQZoneField);


        jHeightField.setBorder(BorderFactory.createTitledBorder("Height"));
        jHeightField.setText ((new Integer(barCodeBean1.getBarHeight())).toString());

  		jHeightField.addKeyListener (new java.awt.event.KeyAdapter () {
          public void keyReleased (java.awt.event.KeyEvent evt) {
				JTextField jtmpfield=(JTextField)evt.getSource();
				String s=jtmpfield.getText();
		        short shno=0;
				try
				{
				  shno=(short)Integer.parseInt(s);
				}
				catch(NumberFormatException e)
				{
				}
				
				barCodeBean1.setBarHeight(shno);
				validate();

          }
        }
        );       
    
		  jPanel2.add (jHeightField);

		  // Ration
          jRatioField.setBorder(BorderFactory.createTitledBorder("Ratio"));
		   jRatioField.setText ((new Float(barCodeBean1.getBarRatio())).toString());

  			jRatioField.addKeyListener (new java.awt.event.KeyAdapter () {
			  public void actionPerformed (java.awt.event.ActionEvent evt) {
					JTextField jtmpfield=(JTextField)evt.getSource();
					String s=jtmpfield.getText();
					float fno=(float)0.0;
					try
					{
					  fno=(float)Float.parseFloat(s);
					}
					catch(NumberFormatException e)
					{
					   
					}
					barCodeBean1.setBarRatio(fno);
					validate();

			  }
			}
			);       
    
		jPanel2.add (jRatioField);


       
	   // bgcolor      jbutton
	  jBGColorButton.setText("Background Color");
	  jPanel2.add(jBGColorButton);
	  jBGColorButton.addActionListener (new java.awt.event.ActionListener () 
	  {
			public void actionPerformed (java.awt.event.ActionEvent evt) 
			{
				Color clr=choseColor(barCodeBean1.getBackground());
				if(clr!=null)
					barCodeBean1.setBackground(clr);
			}
		}
	  );

	   jBarColorButton.setText("Foreground Color");
	  jBarColorButton.addActionListener (new java.awt.event.ActionListener () 
	  {
			public void actionPerformed (java.awt.event.ActionEvent evt) 
			{
				Color clr=choseColor(barCodeBean1.getForeground());
				if(clr!=null)
					barCodeBean1.setForeground(clr);
			}
		}
	  );

	   jPanel2.add(jBarColorButton);
      
	  // bearermode
	  jBearerCheckBox.setSelected(barCodeBean1.getBarBearerMode());
	  jPanel2.add(jBearerCheckBox);

	  jBearerCheckBox.addItemListener(new ItemListener ()
	  {
	      public void itemStateChanged(ItemEvent e)
		  {
		      handleCheckBox(e);
		  }   
	  }
	  );


      // transparency 
	  jTransparentCheckBox.setSelected(barCodeBean1.getBarTransparent());
	  jPanel2.add(jTransparentCheckBox);

	  jTransparentCheckBox.addItemListener(new ItemListener ()
	  {
	      public void itemStateChanged(ItemEvent e)
		  {
		      handleCheckBox(e);
		  }   
	  }
	  );

	  // check digits
	  jCheckDigitsCheckBox.setSelected(barCodeBean1.getBarCheckEnable());
	  jPanel2.add(jCheckDigitsCheckBox);

	  jCheckDigitsCheckBox.addItemListener(new ItemListener ()
	  {
	      public void itemStateChanged(ItemEvent e)
		  {
		      handleCheckBox(e);
		  }   
	  }
	  );

	  // HR display
	  jHRDisplayCheckBox.setSelected(barCodeBean1.getBarHRDisplay());
	  jPanel2.add(jHRDisplayCheckBox);

	  jHRDisplayCheckBox.addItemListener(new ItemListener ()
	  {
	      public void itemStateChanged(ItemEvent e)
		  {
		      handleCheckBox(e);
		  }   
	  }
	  );

	  
	   // HR Font      font box
	   jHRFontButton.setText("HR Font");

	  jHRFontButton.addActionListener (new java.awt.event.ActionListener () 
	  {
			public void actionPerformed (java.awt.event.ActionEvent evt) 
			{
				Font fn=choseFont(barCodeBean1.getBarHRFont());
				if(fn!=null)
				{
					barCodeBean1.setBarHRFont(fn);
					validate();
				}
			}
		}
	  );

	   jPanel2.add(jHRFontButton);

	 
	   // Top comment Font  font box
	   jTopFontButton.setText("Top Comment Font");

	  jTopFontButton.addActionListener (new java.awt.event.ActionListener () 
	  {
			public void actionPerformed (java.awt.event.ActionEvent evt) 
			{
				Font fn=choseFont(barCodeBean1.getBarTopCommentFont());
				if(fn!=null)
				{
					barCodeBean1.setBarTopCommentFont(fn);
					validate();
				}
			}
		}
	  );


	   jPanel2.add(jTopFontButton);
	   // add to TopFontBox
//	   jPanel2.add(jTopFontCombo);
	   // bottom Font  font box
	   jBottomFontButton.setText("Bottom Comment Font");

	  jBottomFontButton.addActionListener (new java.awt.event.ActionListener () 
	  {
			public void actionPerformed (java.awt.event.ActionEvent evt) 
			{
				Font fn=choseFont(barCodeBean1.getBarBottomCommentFont());
				if(fn!=null)
				{
					barCodeBean1.setBarBottomCommentFont(fn);
					validate();
				}
			}
		}
	  );

	   jPanel2.add(jBottomFontButton);

	   // add to BottomFontBox
	   //jPanel2.add(jBottomFontCombo);

    getContentPane().add (jparpanel, java.awt.BorderLayout.SOUTH);

    jPrint.setText ("Print");
    jPrint.setActionCommand ("jPrint");
    jPrint.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
	    // barCodeBean1.putPngImageToFile("c:\\myjavatest.png");
        PrintActionPerformed (evt);
      }
    }
    );

	JButton jSaveToFile =new JButton();
	jSaveToFile.setText ("Save As PNG file");
    jSaveToFile.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
	     SaveActionPerformed(evt);
	
      }
    }
    );

	JPanel jTop=new JPanel();
	jTop.add(jPrint);
	jTop.add(jSaveToFile);

    getContentPane().add (jTop, java.awt.BorderLayout.NORTH);

    pack ();
  }

  protected void BeanPropertyChanged(PropertyChangeEvent evt)
  {
    // System.out.println(evt.getPropertyName());
		 String sname=evt.getPropertyName();
		 if(sname.equals("BarHeight"))
		     jHeightField.setText((new Integer(barCodeBean1.getBarHeight())).toString());
		 else if(sname.equals("BarNarrowWidth"))
		     jNarrowField.setText((new Integer(barCodeBean1.getBarNarrowWidth())).toString());
		 else if(sname.equals("BarQuietZone"))
		 {
		     jQZoneField.setText((new Integer(barCodeBean1.getBarQuietZone())).toString());
		 }
		 else if(sname.equals("BarMessage"))
		 {
		     jMessageField.setText(barCodeBean1.getBarMessage());
		 }
		 else if(sname.equals("BarScaleMode"))
		 {
		     jUnitCombo.setSelectedIndex(barCodeBean1.getBarScaleMode());
		 }
		 else if(sname.equals("BarCheckEnable"))
		 {
			jCheckDigitsCheckBox.setSelected(barCodeBean1.getBarCheckEnable());		
		 }
		 else if(sname.equals("BarBearerMode"))
		 {
			jBearerCheckBox.setSelected(barCodeBean1.getBarBearerMode());
		 }
		 else if(sname.equals("BarSymbology"))
		 {
			int isym=barCodeBean1.getBarSymbology();
			if(isym==barCodeBean1.BAR128||isym==barCodeBean1.BAREAN128||
			isym==barCodeBean1.BARHIBCLIC128||isym==barCodeBean1.BARHIBCEAN128)
			{
			   // enable 128 set selections
				j128StartTypeCombo.setEnabled(true);
			}
			else
			{
			   // disable 128 set selections
			   j128StartTypeCombo.setEnabled(false);
			}
		 }
		 else if(sname.equals("BarNarrowWidth"))
		 {
		     jNarrowField.setText((new Integer(barCodeBean1.getBarNarrowWidth())).toString());
		 }
	 barCodeBean1.invalidate();
  }
  
  // my function
  protected Color choseColor(Color iniColor)
	  {
		JColorChooser pi=new JColorChooser(iniColor);
			return pi.showDialog(this,"Color Dialog",Color.black);
	  } 

  protected Font choseFont(Font iniFont)
  {
      // init our dialog for color
	  FontDialog dlg=new FontDialog(this);
	  dlg.showDialog(iniFont);
	  return dlg.newFont;
	
  }

  protected void handleCheckBox(ItemEvent e)
  {  
		Object source = e.getItemSelectable();
		boolean bselected=(e.getStateChange() == ItemEvent.SELECTED);
		if(source==jTransparentCheckBox)
 			barCodeBean1.setBarTransparent(bselected);
		else if(source==jCheckDigitsCheckBox)
		{
			barCodeBean1.setBarCheckEnable(bselected);
		}
		else if(source==jHRDisplayCheckBox)
		{
		    barCodeBean1.setBarHRDisplay(bselected);
		}
		else if(source==jBearerCheckBox)
			barCodeBean1.setBarBearerMode(bselected);
		validate();
  }
	   
  public int print(Graphics g, PageFormat pf, int pi) throws PrinterException
  {    if (pi >= 1) 
    {
        return Printable.NO_SUCH_PAGE;    
    }  
   g.translate((int)pf.getImageableX(),(int)pf.getImageableY());  
   
   barCodeBean1.print(g);
    return Printable.PAGE_EXISTS;
  }

  
  private void jMessageFieldActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMessageFieldActionPerformed
// Add your handling code here:
  }//GEN-LAST:event_jMessageFieldActionPerformed

  private void jBorderComboItemStateChanged (java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jBorderComboItemStateChanged
// Add your handling code here:
  }//GEN-LAST:event_jBorderComboItemStateChanged
private void jRotationComboItemStateChanged(java.awt.event.ItemEvent evt)
  {
    int s=5;
    String stmp=(String)evt.getItem();
    }
  private void jButton1ActionPerformed (java.awt.event.ActionEvent evt) {

  }

  private void SaveActionPerformed(java.awt.event.ActionEvent evt)
  {
		JFileChooser chooser = new JFileChooser();
		if(chooser.showSaveDialog(this)==JFileChooser.APPROVE_OPTION)
		{
		    barCodeBean1.setBarScaleMode(barCodeBean1.SCALEPOINT); // onle POINT scale is supported if output as PNG file
			barCodeBean1.putPngImageToFile((chooser.getSelectedFile()).getPath());
		}
  }



private void PrintActionPerformed (java.awt.event.ActionEvent evt) {
  PrinterJob printJob = PrinterJob.getPrinterJob();
  printJob.setPrintable(this);    
  if (printJob.printDialog()) 
  {
        try
      {                
        printJob.print();
      } 
      catch (Exception ex) 
      {               
        ex.printStackTrace();
      }        
   }  
  }

  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
    System.exit (0);
  }//GEN-LAST:event_exitForm

  public void SetMessage(String mes)
  {
     barCodeBean1.setBarMessage(mes);
  }
  /**
  * @param args the command line arguments
  */
  public static void main (String args[]) {
    BarCodePicker tmp=new BarCodePicker();
	tmp.setSize(620,600);
    tmp.show ();
    tmp.SetMessage("1234567890");
	tmp.validate();
    
  }

	  // Variables declaration - do not modify//GEN-BEGIN:variables
	  private dsx.JBarCodePro2.BarCodeBean barCodeBean1;
	  private javax.swing.JPanel jPanel2;
	  private javax.swing.JComboBox jSymbolCombo;
	  private javax.swing.JComboBox jUnitCombo;
	  private javax.swing.JComboBox jRotationCombo;
	  private javax.swing.JComboBox jAlignCombo;
	  private javax.swing.JComboBox jBorderCombo;
	  private javax.swing.JTextField jMessageField;
	  private javax.swing.JTextField jSuppleField;
	  private javax.swing.JTextField jNarrowField;
	  private javax.swing.JTextField jQZoneField;
	  private javax.swing.JTextField jHeightField;
	  private javax.swing.JTextField jRatioField;
	  private javax.swing.JCheckBox jTransparentCheckBox;
	  private javax.swing.JCheckBox jCheckDigitsCheckBox;
	  private javax.swing.JCheckBox jBearerCheckBox;
	  private javax.swing.JCheckBox jHRDisplayCheckBox;
	  private javax.swing.JButton jPrint;

      private javax.swing.JButton jBGColorButton;
	  private javax.swing.JButton jBarColorButton;
	  private javax.swing.JButton jHRFontButton;
	  private javax.swing.JButton jTopFontButton;
	  private javax.swing.JButton jBottomFontButton;
	  private javax.swing.JComboBox j128StartTypeCombo;



	  // top comment using text area
	  private javax.swing.JTextArea  jTopCommentArea;
	  private javax.swing.JTextArea  jBottomCommentArea;
	  private javax.swing.JButton jPrintBtn;
}

class FontDialog extends javax.swing.JDialog
{
    FontDialog(JFrame frame)
	{
	   // init members
	   super(frame,true);
	   bcancel=false;
	   newFont=null;
	   
		jFontNameBox=new javax.swing.JComboBox();
		jFontStyleBox=new javax.swing.JComboBox();
		jFontSizeBox=new javax.swing.JComboBox();

		jFontPanel=new javax.swing.JPanel();
		jFontPanel.add(jFontNameBox);
		jFontPanel.add(jFontStyleBox);
		jFontPanel.add(jFontSizeBox);

		getContentPane().add(jFontPanel,java.awt.BorderLayout.CENTER);

		addWindowListener (new java.awt.event.WindowAdapter () {
			  public void windowClosing (java.awt.event.WindowEvent evt) {
			  //   bcancel=true;
			 
			  }
			}
			);

		FillFontList(jFontNameBox);
		// fill style
		jFontStyleBox.addItem("Plain");
		jFontStyleBox.addItem("Bold");
		jFontStyleBox.addItem("Italic");
		jFontStyleBox.addItem("BOLD and Stylic");

		// fill size
		for(int i=0;i<100;i++)
		{
			jFontSizeBox.addItem(new Integer(i));
		}

        JPanel okcancelPanel= new JPanel();
		getContentPane().add(okcancelPanel,java.awt.BorderLayout.SOUTH);

	    JButton okButton = new JButton("OK");
       // final JButton setButton = new JButton("Set");
        okButton.addActionListener(new ActionListener() {
			  public void actionPerformed(ActionEvent e) {
			  
			  sFamily=(String)(jFontNameBox.getSelectedItem());
			  iStyle=jFontStyleBox.getSelectedIndex();
			  if(iStyle==0)
				iStyle=Font.PLAIN;
			  else if(iStyle==1)
			    iStyle=Font.BOLD;
			  else if(iStyle==2)
			    iStyle=Font.ITALIC;
			  else
			    iStyle=Font.BOLD+Font.ITALIC;
			  iSize=((Integer)(jFontSizeBox.getSelectedItem())).intValue();
			  newFont=new Font(sFamily,iStyle,iSize);		
			  setVisible(false);
			 // dispose();
			 
            }
        });
		okcancelPanel.add(okButton );

		JButton cancelButton = new JButton("Cancel");
       // final JButton setButton = new JButton("Set");
        cancelButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
               // ListDialog.dialog.setVisible(false);
			  // dispatchEvent(new WindowEvent(this,WindowEvent.WINDOW_CLOSING));
			  setVisible(false);
			  dispose();
			 
            }
        });
		okcancelPanel.add(cancelButton);

	

		pack ();
		
		
	}

	public void showDialog(Font font)
	{
//		set selected items
        // set selected font family
		String sfontname=font.getFamily();
		int icount=jFontNameBox.getItemCount();
	//	System.out.println(sfontname);
		int idotindex=sfontname.indexOf(".");
		if(idotindex>0)
			sfontname=sfontname.substring(0,idotindex);
		for(int i=0;i<icount;i++)
		{
		    if(sfontname.compareToIgnoreCase((String)jFontNameBox.getItemAt(i))==0)
			{
				jFontNameBox.setSelectedIndex(i);
				break;
			}
		}
		// set selected style
		int itmp=font.getStyle();
		int idex=-1;
		if(itmp==font.PLAIN)
			idex=0;
		else if(itmp==font.BOLD)
			idex=1;
		else if(itmp==font.ITALIC)
			idex=2;
		else if(itmp==(font.ITALIC+font.BOLD))
			idex=3;
		jFontStyleBox.setSelectedIndex(idex);
		// set selected size
		jFontSizeBox.setSelectedIndex(font.getSize());
		setSize(350,300);

		setVisible(true);
	//	if(bcancel)
	//		return null;
	//	return new Font(sFamily,iStyle,iSize);
	}
	protected void FillFontList(JComboBox comBox)
   {
		GraphicsEnvironment env=GraphicsEnvironment.getLocalGraphicsEnvironment();
		String sfontname[]=env.getAvailableFontFamilyNames();
		int ilen=sfontname.length;
		// only add Dialog, SansSerif, Serif, Monospaced, DialogInput, if there is match
		// or Arial and Time
		String sarnames[]={"Dialog","SansSerif","Monospaced","DialogInput","Serif"};
		int iavlen=sarnames.length;
		for(int i=0;i<ilen;i++)
		{
		   for(int j=0;j<iavlen;j++)
		   {  
		        if(sarnames[j].compareToIgnoreCase(sfontname[i])==0)
				{
					comBox.addItem(sfontname[i]);
					break;
				}
		   }
		}		
   }
    private String sFamily;
	private int    iStyle;
	private int    iSize;
    private boolean bcancel;
	private javax.swing.JComboBox jFontNameBox;
	private javax.swing.JComboBox jFontStyleBox;
	private javax.swing.JComboBox jFontSizeBox;
	private javax.swing.JPanel jFontPanel;
	private javax.swing.JPanel jPreviewPanel;
	public Font newFont;
}

